#include <math.h>
#include <stdio.h>
#include "mex.h" /* Always include this */
void mexFunction(int nlhs, mxArray *plhs[], /* Output variables */
int nrhs, const mxArray *prhs[]) /* Input variables */
{ 
    #define B_OUT plhs[0]
    #define A_IN prhs[0]
    #define X_IN prhs[1]
    #define Y_IN prhs[2]
    #define rad_IN prhs[3]
            
    double *B, *A, *X, *Y;
    int M, N, m, n, rad, h, k;
    double eps=1.0E-15;
    double pi=3.141592653589793;
    double *Xfl, *Yfl;
    
    M = mxGetM(A_IN); /* Get the dimensions of A */
    N = mxGetN(A_IN);
    A = mxGetPr(A_IN); /* Get the pointer to the data of A */
    X = mxGetPr(X_IN); /* Get the pointer to the data of X */
    Y = mxGetPr(Y_IN); /* Get the pointer to the data of Y */
    rad = mxGetScalar(rad_IN); /* Get the pointer to the data of rad */
    B_OUT = mxCreateDoubleMatrix(M, N, mxREAL); /* Create the output matrix */
    B = mxGetPr(B_OUT); /* Get the pointer to the data of B */
    //rad = 3;
    
     
    for(n = 0; n < N; n++) /* Compute a matrix with normalized columns */ 
    {
        for(m = 0; m < M; m++) {
        
            int rad1, rad2, rad3, rad4, xn_a, yn_a;
            double xn, yn, dx_a, dy_a, sincx_a, sincy_a;
            double buf = 0.0;
            
            xn = X[m + M*n]-1;
            yn = Y[m + M*n]-1;
            xn_a = floor(xn);
            yn_a = floor(yn);
            
            rad1 = xn_a-rad; if (rad1<0)   { rad1=0; }
            rad2 = xn_a+rad; if (rad2>N-1)   { rad2=N-1; }
            rad3 = yn_a-rad; if (rad3<0)   { rad3=0; }
            rad4 = yn_a+rad; if (rad4>M-1)   { rad4=M-1; }
            
            for (k = rad1; k <= rad2; k++) {
            dx_a	= (k-xn)*pi;
            sincx_a = sin(dx_a+eps)/(dx_a+eps);
            for (h = rad3; h<= rad4; h++) {
                dy_a   = (h-yn)*pi;
                sincy_a = sin(dy_a+eps)/(dy_a+eps);
                //buf += (sincx_a * sincy_a * A[m+h+M*(n+k)]);
                buf += (sincx_a * sincy_a * A[h+M*(k)]);
                //buf += sincy_a;
                } // for h
            } // for k
                    
            B[m + M*n] = buf;
            //B[m + M*n] = A[m + M*n];
        }
    }    
    return;
}