function [Xdisparity Ydisparity immult peaks]=disparity_computation(im1,im2,rsearch,weight)
if nargin<4
    weight='peaks';
end

% new
% im1dum=slidingAvgDavis(im1,3);
% im2dum=slidingAvgDavis(im2,3);
% immult=im1dum.*im2dum;
% clear im1dum im2dum;
%

immult=im1.*im2;
[J I]=size(im1);
im1pos=im1>0; im2pos=im2>0;
im1=im1+abs(min(im1(:)))+eps;
im2=im2+abs(min(im2(:)))+eps;

[X1 Y1]=meshgrid(1:I,1:J);
[X2 Y2]=meshgrid(1:I,1:J);
Xpos1=X1; Ypos1=Y1;
Xpos2=X2; Ypos2=Y2;
%% get the maxima
peaks=get_max(immult,weight);
peaksIndex=find(peaks>0);

%% subpixel position
[X1sub Y1sub]=  subpixel_position(im1); X1sub(isnan(X1sub))=0; Y1sub(isnan(Y1sub))=0;
[X2sub Y2sub]=  subpixel_position(im2); X2sub(isnan(X2sub))=0; Y2sub(isnan(Y2sub))=0;

%% main loop
for nIndex=1:numel(peaksIndex);
    peakIndexLoc=peaksIndex(nIndex);

    % discrete particles positions
    [ip1 jp1]=find_particles2(im1,peakIndexLoc,rsearch);
    [ip2 jp2]=find_particles2(im2,peakIndexLoc,rsearch);
    % subpixel position
    if (ip1*ip2*jp1*jp2>0)
        Xpos1(peakIndexLoc)=X1(jp1,ip1)+X1sub(jp1,ip1);
        Ypos1(peakIndexLoc)=Y1(jp1,ip1)-Y1sub(jp1,ip1);
        Xpos2(peakIndexLoc)=X2(jp2,ip2)+X2sub(jp2,ip2);
        Ypos2(peakIndexLoc)=Y2(jp2,ip2)-Y2sub(jp2,ip2);
    else
        peaks(peakIndexLoc)=0;
    end
end

% %% main loop with 2D Gaussian!!!!
% for nIndex=1:numel(peaksIndex);
%     peakIndexLoc=peaksIndex(nIndex);
% 
%     % discrete particles positions
%     [ip1 jp1]=find_particles2(im1,peakIndexLoc,rsearch);
%     [ip2 jp2]=find_particles2(im2,peakIndexLoc,rsearch);
%     % subpixel position with 2D Gaussian!!!!
%     if (ip1*ip2*jp1*jp2>0 & jp1>2 & ip1>2 & jp2>2 & ip2>2 & jp1<(J-1) & jp2<(J-1) & ip1<(I-1) & ip2<(I-1))
%         im1loc=im1(jp1-1:jp1+1,ip1-1:ip1+1);
%         im2loc=im2(jp2-1:jp2+1,ip2-1:ip2+1);
%         [dx1,dy1]=GaussFit2D(im1loc,5,'TH');
%         [dx2,dy2]=GaussFit2D(im2loc,5,'TH');
%         Xpos1(peakIndexLoc)=X1(jp1,ip1)+dx1;
%         Ypos1(peakIndexLoc)=Y1(jp1,ip1)-dy1;
%         Xpos2(peakIndexLoc)=X2(jp2,ip2)+dx2;
%         Ypos2(peakIndexLoc)=Y2(jp2,ip2)-dy2;
% %         figure(1), clf, imagesc(im1loc), axis equal, axis tight
% %         dx1,dy1, pause
%     else
%         peaks(peakIndexLoc)=0;
%     end
% end

%% Disparity matrices
Xdisparity=Xpos2-Xpos1; 
Ydisparity=Ypos2-Ypos1;

%% Thresholding
Thr= 0*std(immult(:))/3;
Xdisparity=Xdisparity.*(immult>Thr).*im1pos.*im2pos;
Ydisparity=Ydisparity.*(immult>Thr).*im1pos.*im2pos;
peaks=peaks.*(immult>Thr).*im1pos.*im2pos;
