function imdef = image_def(im,displ,X,Y)
% function that performs the image deformation through the sinc
% interpolation
% im: image pair, having size (J,I,2)
% displ: displacement in the two directions, of size (leny,lenx,2)
% X and Y: vector positions, of size (J,I)

%% dense predictor (displacement in each pixel position)
displ(:,:,2)=-displ(:,:,2);
[J,I,~]=size(im);
densepred=zeros(J,I,2);
grdx=X(1,:); grdy=Y(:,1);
parfor h=1:2
    densepred(:,:,h)=build_predictor(grdx,grdy,displ(:,:,h),I,J);	% dense predictor 
end
[tmpx,tmpy]=meshgrid(1:I,1:J);

%% displacement to be imposed to the two images
xtransf=cell(1,2); ytransf=cell(1,2);
xtransf{1}=tmpx - 0.5*densepred(:,:,1);
xtransf{2}=tmpx + 0.5*densepred(:,:,1);
ytransf{1}=tmpy - 0.5*densepred(:,:,2);
ytransf{2}=tmpy + 0.5*densepred(:,:,2);
clear tmpx tmpy densepred

%% deformation (sinc interpolation for the images, based on the predictor)
imdef=zeros(J,I,2);
parfor h=1:2
    %imdef(:,:,h)=sincinterp_even(im(:,:,h),xtransf{h},ytransf{h},6);
    %imdef(:,:,h)=sincinterp(im(:,:,h),xtransf{h},ytransf{h},3);
    imdef(:,:,h)=Whittaker7(im(:,:,h),xtransf{h},ytransf{h},3);
end
% [Xim Yim]=meshgrid(1:I,1:J);
% parfor h=1:2
%      imdef(:,:,h)=interp2(Xim,Yim,im(:,:,h),xtransf{h},ytransf{h},'*spline');
% end
% imdef(isnan(imdef))=0;

end

