function matrixOut = slidingAvgDavis(matrixIn, ker)

%Initial error statements and definitions
if nargin<2, error('Not enough input arguments'), end
if length(ker(1))~=1, error('Nr must be a scalar'), end

% smoothing
if ker>1
    [J I]=size(matrixIn);
    
    % rim construction
    if mod(I,2)==0 Ir=I+1; else Ir=I; end
    if mod(J,2)==0 Jr=J+1; else Jr=J; end
    matrixIn2=zeros(Jr,Ir);
    matrixIn2(1:J,1:I)=matrixIn;
    %[Xr Yr]=meshgrid(1:Ir,1:Jr);
    %z=find(matrixIn2==0); nz=find(matrixIn2~=0);
    %matrixIn2(z)=griddata(Xr(nz),Yr(nz),matrixIn2(nz),Xr(z),Yr(z),'nearest');
    
    %filt=zeros(size(matrixIn2));
    [X Y]=meshgrid(-(Ir-1)/2:(Ir-1)/2,-(Jr-1)/2:(Jr-1)/2);
    sigma=-log(1-2/ker);
    r=abs(X)+abs(Y);
    filt=exp(-sigma*r);
    filt(J+1:Jr,I+1:Ir)=0;
    filt=filt/sum(filt(:));
    Ishift=(Ir+1)/2; Jshift=(Jr+1)/2;
    
    Mf=ifft2(fft2(filt).*fft2(matrixIn2));
    matrixOut=circshift(Mf,[Jshift,Ishift]);
    
    matrixOut=matrixOut(1:J,1:I);
else
    matrixOut=matrixIn;
end % if ker>1

end % end function

