clc; clear; close all;

%% data
N=5; %kernel of the 2nd order regression (NxN)
first=505;
last=511;

foldread='F:\andrea\uncertainty estimation\data\jet_tot\Pyramid\ws17n5\time_regr9\';
fileroot='B0';
zerostr='0000';
fileapp='.dat';
foldwrite=[foldread 'space_regr' num2str(N) '\'];
if exist(foldwrite,'dir')~=7
    mkdir(foldwrite);
end

%% main loop
if matlabpool('size')==0
    matlabpool;
end
count=0;
for i=first:last
        count=count+1;
        istr=num2str(i);
        disp(['processing field ' istr ' of ' num2str(last)])
        numstr=[zerostr(1:end-length(istr)) istr];
        filename=[fileroot numstr fileapp];
        fid=fopen([foldread filename]); %read the file
        for q=1:3 tline = fgetl(fid); end
        M=textscan(fid,'%f %f %f %f %f %f %f %f');
        fclose(fid);
        u=M{3};
        v=M{4};
        
        if i==first
            fid=fopen([foldread filename]); %read the file
            for q=1:3 tline = fgetl(fid); end
            equalsign = findstr(tline, '=');
            commasign = findstr(tline, ',');
            J=str2num(tline(equalsign(2)+1:commasign(2)-1));
            I=str2num(tline(equalsign(3)+1:end));
            fclose(fid);
            %reshape
            X=M{1};
            Y=M{2};
            utot=zeros(J,I,last-first+1);
            vtot=zeros(J,I,last-first+1);
        end
        
        u=reshape(u,J,I);
        v=reshape(v,J,I);
        uregr=space_regression_func(u,N);
        vregr=space_regression_func(v,N);
        %% save the data
        savematrix=[X Y uregr(:) vregr(:)];

        fid=fopen([foldwrite filename],'w');
        fprintf(fid,'%s\n',['TITLE = "' filename '"']);
        fprintf(fid,'%s\n','VARIABLES = "x", "y", "u", "v"');
        fprintf(fid,'%s\n',['ZONE T="Frame 0", I=' num2str(size(u,1)) ', J=' num2str(size(u,2))]);
        fprintf(fid,'%4u\t %4u\t %4.8f\t %4.8f\t \n',savematrix');
        fclose(fid);

end
