function [xsub ysub]=  subpixel_position(im)
% function that computes the subpixel position of the particles

% to avoid non positive values
if min(im(:))<0
    im=im+abs(min(im(:)))+eps;
end

%logarithm of the image
im=log(im);

%shifted images
[J I]=size(im);
imE=zeros(J,I)+eps; imW=zeros(J,I)+eps; imN=zeros(J,I)+eps; imS=zeros(J,I)+eps;
imE(:,1:end-1)=im(:,2:end);
imW(:,2:end)=im(:,1:end-1);
imN(2:end,:)=im(1:end-1,:);
imS(1:end-1,:)=im(2:end,:);

%subpixel position
xsub=(imW-imE)./2./(imE+imW-2*im);
ysub=(imS-imN)./2./(imS+imN-2*im);