clc; clear; close all

%% Uncertainty quantification by Particle Disparity

% Uncertainty quantification method based on the paper:

% Sciacchitano A, Wieneke B and Scarano F (2013), PIV uncertainty quantification by image matching, Meas. Sci. Technol. 24 045302 (16pp)
% http://iopscience.iop.org/article/10.1088/0957-0233/24/4/045302/meta;jsessionid=8DD2705CCBCA46BAF812BA74B583412D.c1.iopscience.cld.iop.org


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Parameters

% FileStart:        first displacement field to be read 
% FileEnd:          last displacement field to be read
% FileStep:         increment between displacement fields
% disp_fold:        folder where the displacement fields (in pixel units) are stored
% im_fold:          folder where the images are stored
% fold_write:       folder where the output is stored
% ws:               interrogation window (linear) size (in pixel units)
% window_weight:    interrogation window weight: Gaussian ('gauss') or Top Hat ('tophat')
% ROI:              Region Of Interest where the uncertainty is computed (1x4 vector)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%% Reading Parameters
FileStart=10;
FileEnd=10;
FileStep=1;


im_fold = 'TestData\';
disp_fold = 'TestData\';
fold_write='TestData\Uncertainty\';

ws=16; % pixels
window_weight='gauss'; %'gauss', 'tophat'

ROI = [220 430 10 450]; % [xmin xmax ymin ymax], all in pixel units

%% Call the processing function
addpath([pwd '\PathFunctions\']);
Uncertainty_PD_proc
